<template>
  <li :class="cssClass">
    <span class="rules-icone"></span>
    {{ rule.nom }}
  </li>
</template>

<script>
export default {
  props: {
    rule: {
      type: Object,
      default: null,
    },
    password: {
      type: String,
      default: '',
    },
  },
  data() {
    return {
      regex: new RegExp(this.rule.condition),
      cssClass: 'default',
    };
  },
  watch: {
    password: {
      handler() {
        if (
          this.rule.condition == null ||
          this.rule.condition === '' ||
          this.password == null ||
          this.password === ''
        ) {
          this.rule.valid = null;
          this.cssClass = 'default';
        } else if (this.regex.test(this.password.trim())) {
          this.rule.valid = true;
          this.cssClass = 'fort';
        } else {
          this.rule.valid = false;
          this.cssClass = 'faible';
        }
      },
      immediate: true,
    },
  },
};
</script>

<style scoped lang="scss">
@import '~/assets/css/_variables';

li {
  display: flex;
  align-items: center;
  padding: 0.4em 0;
  font-size: $size-7;
  cursor: default;

  /deep/ .rules-icone {
    flex-basis: 2em;
    display: flex;
    position: relative;
    align-items: center;
  }

  &.default {
  }

  &.faible {
    .rules-icone:before {
      position: absolute;
      content: '';
      left: 0;
      height: 2px;
      width: 15px;
      background-color: var(--rules-item-color);
      transform: rotate(-45deg);
      margin-right: 1em;
    }

    .rules-icone:after {
      position: absolute;
      content: '';
      left: 0;
      height: 2px;
      width: 15px;
      background-color: var(--rules-item-color);
      transform: rotate(45deg);
      margin-right: 1em;
    }
  }

  &.fort {
    .rules-icone:before {
      position: absolute;
      content: '';
      left: 0;
      height: 10px;
      width: 15px;
      border-left: 2px solid var(--rules-item-color);
      border-bottom: 2px solid var(--rules-item-color);
      transform: rotate(-45deg);
      margin-right: 1em;
    }
  }
}
</style>
